    .586
    .model compact, stdcall
    option casemap :none   ; case sensitive

    include \masm32\include\windows.inc
    include \masm32\include\kernel32.inc

    ;includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    
.data

.code

; ##########################################################################

LibMain proc hInstDLL:DWORD, reason:DWORD, unused:DWORD

        .if reason == DLL_PROCESS_ATTACH
            mov eax, TRUE
            ; -----------------------------
            ; If error at startup, return 0
            ; System will abort loading DLL
            ; -----------------------------

        .elseif reason == DLL_PROCESS_DETACH
        .elseif reason == DLL_THREAD_ATTACH
        .elseif reason == DLL_THREAD_DETACH
        .endif
        ret

LibMain Endp

Endian2 proc endianInput:dword, endianOutput:dword
	mov edx, endianInput		;mem = B1 B2
	mov ax, word ptr[edx]		;ax = B2 B1
	xchg al, ah					;ax = B1 B2
	mov edx, endianOutput
	mov word ptr[edx], ax		;mem = B2 B1
	ret
Endian2 endp

Endian2Array proc endianInput:dword, endianOutput:dword, arrayCount:dword
	mov ecx, arrayCount
	test ecx, ecx
	je doneEndian2Array
	nextEndian2Array:
		mov edx, endianInput				;mem = B1 B2
		mov ax, word ptr[edx+2*ecx-2]		;ax = B2 B1
		xchg al, ah							;ax = B1 B2
		mov edx, endianOutput
		mov word ptr[edx+2*ecx-2], ax		;mem = B2 B1
		dec ecx
		test ecx, ecx
		je doneEndian2Array
		jmp nextEndian2Array
	doneEndian2Array:
	ret
Endian2Array endp

Endian4 proc endianInput:dword, endianOutput:dword
	mov edx, endianInput			;mem = B1 B2 B3 B4
	mov ax, word ptr[edx]			;ax = B2 B1
	mov bx, word ptr[edx+2]			;bx = B4 B3
	xchg al, ah						;ax = B1 B2
	xchg bl, bh						;bx = B3 B4
	shl eax, 16						;eax = B1 B2 00 00
	mov ax, bx						;eax = B1 B2 B3 B4
	mov edx, endianOutput
	mov dword ptr[edx], eax			;mem = B4 B3 B2 B1
	ret
Endian4 endp

Endian4Array proc endianInput:dword, endianOutput:dword, arrayCount:dword
	mov ecx, arrayCount
	test ecx, ecx
	je doneEndian4Array
	nextEndian4Array:
		mov edx, endianInput				;mem = B1 B2 B3 B4
		mov ax, word ptr[edx+4*ecx-4]		;ax = B2 B1
		mov bx, word ptr[edx+4*ecx-2]		;bx = B4 B3
		xchg al, ah							;ax = B1 B2
		xchg bl, bh							;bx = B3 B4
		shl eax, 16							;eax = B1 B2 00 00
		mov ax, bx							;eax = B1 B2 B3 B4
		mov edx, endianOutput
		mov dword ptr[edx+4*ecx-4], eax		;mem = B4 B3 B2 B1
		dec ecx
		test ecx, ecx
		je doneEndian4Array
		jmp nextEndian4Array
	doneEndian4Array:
	ret
Endian4Array endp

Endian8 proc endianInput:dword, endianOutput:dword
	mov edx, endianInput			;mem = B1 B2 B3 B4 B5 B6 B7 B8
	mov ax, word ptr[edx]			;ax = B2 B1
	mov bx, word ptr[edx+2]			;bx = B4 B3
	xchg al, ah						;ax = B1 B2
	xchg bl, bh						;bx = B3 B4
	shl eax, 16						;eax = B1 B2 00 00
	mov ax, bx						;eax = B1 B2 B3 B4
	mov edx, endianOutput
	mov dword ptr[edx+4], eax		;mem = B4 B3 B2 B1

	mov edx, endianInput			;mem = B1 B2 B3 B4 B5 B6 B7 B8
	mov ax, word ptr[edx+4]			;ax = B6 B5
	mov bx, word ptr[edx+6]			;bx = B8 B7
	xchg al, ah						;ax = B5 B6
	xchg bl, bh						;bx = B7 B8
	shl eax, 16						;eax = B5 B6 00 00
	mov ax, bx						;eax = B5 B6 B7 B8
	mov edx, endianOutput
	mov dword ptr[edx], eax			;mem = B8 B7 B6 B5
	ret
Endian8 endp


Endian8Array proc endianInput:dword, endianOutput:dword, arrayCount:dword
	mov ecx, arrayCount
	test ecx, ecx
	je doneEndian8Array
	nextEndian8Array:
		mov edx, endianInput				;mem = B1 B2 B3 B4 B5 B6 B7 B8
		mov ax, word ptr[edx+8*ecx-8]		;ax = B2 B1
		mov bx, word ptr[edx+8*ecx-6]		;bx = B4 B3
		xchg al, ah							;ax = B1 B2
		xchg bl, bh							;bx = B3 B4
		shl eax, 16							;eax = B1 B2 00 00
		mov ax, bx							;eax = B1 B2 B3 B4
		mov edx, endianOutput
		mov dword ptr[edx+8*ecx-4], eax		;mem = B4 B3 B2 B1

		mov edx, endianInput				;mem = B5 B6 B7 B8
		mov ax, word ptr[edx+8*ecx-4]		;ax = B6 B5
		mov bx, word ptr[edx+8*ecx-2]		;bx = B8 B7
		xchg al, ah							;ax = B5 B6
		xchg bl, bh							;bx = B7 B8
		shl eax, 16							;eax = B5 B6 00 00
		mov ax, bx							;eax = B5 B6 B7 B8
		mov edx, endianOutput
		mov dword ptr[edx+8*ecx-8], eax		;mem = B8 B7 B6 B5

		dec ecx
		test ecx, ecx
		je doneEndian8Array
		jmp nextEndian8Array
	doneEndian8Array:
	ret
Endian8Array endp

End LibMain